/*
	LICENSE DISPLAY - A program to display license information.
	Copyright © 2005-2007  Ricky Romero and Harry Whitfield

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
	License Display - version 1.3
	6 August, 2007
	Copyright © 2005-2007  Ricky Romero and Harry Whitfield
	mailto:g6auc@arrl.net
*/

	function showLicense()
	{
		if (optionKeyDown(system.event.modifiers))
		{
			filesystem.open("Resources/License/GNU-GPL.html");
		}
	}


	function createLicense(mainWindow)	// mainWindow parameter is a window
	{
		license_info = new Window();
		
		license_info.mainWindow = mainWindow;

		with (license_info)
		{
			title="License Agreement";
			alignment="left";
			hOffset=400;
			vOffset=150;
			width=365;
			height=310;
			visible=false;
			shadow=false;
		}

		frame = new Image();
		with (frame)
		{
			window = license_info;
			src="Resources/License/Frame.png";
			hOffset=0;
			vOffset=0;
			width=365;
			height=310;
		}
	
		widgetTitle = new Text();
		with (widgetTitle)
		{
			window = license_info;
			data="License Agreement";
			hOffset=34;
			vOffset=34;
			alignment="left";
			font="Helvetica Neue Bold, Arial Bold";
			size=11;
			color="#FFFFFF";
		}
	
		declineInstruction2 = new Text();
		with (declineInstruction2)
		{
			window = license_info;
			data="If you do not agree with the terms set forth above, please click the";
			alignment="center";
			hOffset=183;
			vOffset=236;
			font="Helvetica Neue";
			size=9;
			color="#FFFFFF";
		}
	
		declineInstruction = new Text();
		with (declineInstruction)
		{
			window = license_info;
			data="Decline button below and destroy this Widget and its documentation.";
			alignment="center";
			hOffset=183;
			vOffset=248;
			font="Helvetica Neue";
			size=9;
			color="#FFFFFF";
		}
		
		license = new TextArea();
		with (license)
		{
			window = license_info;
			data="";
			hOffset=35;
			vOffset=45;
			width=296;
			height=177;
			alignment="left";
			font="Helvetica Neue";
			size=11
			color="#FFFFFF";
			bgColor="#25443C";
			opacity=255;
			bgOpacity=192;
			editable=false;
			tooltip="Alt-click to see the full license text.";
			onMouseUp=showLicense;
		}
	
		acceptShadow = new Text();
		with (acceptShadow)
		{
			window = license_info;
			data="Accept";
			hOffset=329;
			vOffset=279;
			alignment="right";
			font="Helvetica Neue Bold, Arial Bold";
			size=11;
			color="#FFFFFF";
			opacity=192;
			onMouseUp=acceptLicense;
		}

		accept = new Text();
		with (accept)
		{
			window = license_info;
			data="Accept";
			hOffset=329;
			vOffset=278;
			alignment="right";
			font="Helvetica Neue Bold, Arial Bold";
			size=11;
			color="#000000";
			opacity=192;
		}
	
		declineShadow = new Text();
		with (declineShadow)
		{
			window = license_info;
			data="Decline";
			hOffset=236;
			vOffset=279;
			alignment="left";
			font="Helvetica Neue Bold, Arial Bold";
			size=11;
			color="#FFFFFF";
			opacity=192;
			onMouseUp=closeWidget;
		}
	
		decline = new Text();
		with (decline)
		{
			window = license_info;
			data="Decline";
			hOffset=236;
			vOffset=278;
			alignment="left";
			font="Helvetica Neue Bold, Arial Bold";
			size=11;
			color="#000000";
			opacity=192;
		}
		
		license.data = filesystem.readFile("Resources/License/license.txt");
		
		if (preferences.licenseHide.value == "0")
		{
			mainWindow.visible=false;
			license_info.visible = true;
		}
		else
		{
			mainWindow.visible=true;
			license_info.visible = false;
		}
	}

	function acceptLicense()
	{
		var mainWindow = license_info.mainWindow;
		license_info.visible = false; mainWindow.visible = true;

		frame.opacity =
		widgetTitle.opacity =
		declineInstruction.opacity =
		declineInstruction2.opacity =
		license.opacity =
		acceptShadow.opacity =
		accept.opacity =
		declineShadow.opacity =
		decline.opacity = 0;

		preferences.licenseHide.value = "1";
	}

	function displayLicense()
	{
		frame.opacity =
		widgetTitle.opacity =
		declineInstruction.opacity =
		declineInstruction2.opacity =
		license.opacity =
		acceptShadow.opacity =
		accept.opacity =
		declineShadow.opacity =
		decline.opacity = 255;

		preferences.licenseHide.value = "0";
		license_info.visible = true;
	}
	
	function testLicense()
	{
		if (license_info.visible)  { closeWidget(); }
	}
