//	Beat Meter - version 1.0
//	29 July, 2007
//	Copyright 2005-2007 Harry Whitfield
//	mailto:g6auc@arrl.net

var sampleLength = preferences.runLength.value;			// number of samples to be averaged

var metroBeatRate = preferences.beatRate.value;			// metronome beat-rate

beatsPerMin.data = metroBeatRate;

var metroEnabled = preferences.metronomeEnable.value;	// metronome enable

metronome.interval = 60 / metroBeatRate;				// time of one metronome beat
metronome.ticking = (metroEnabled == "1");				// metronome enable
if (metronome.ticking)
{
	play("Resources/Sounds/MetroClick.aif");
	pendulum.rotation = 30;
	beatsPerMin.data = preferences.beatRate.value;
	beatsPerMin.color = "#ffff00";
}
else { pendulum.rotation = 0; }

var arrayLength = 21;	// max sampleLength + 1

var fifo = [];

var on  = 0;	// when on == off, the fifo is empty
var off = 0;

var count = 0;	// number of samples accumulated

var oldTime = new Date().getTime();

var oldInterval = 0;

var sum = 0;

function push(val)
{
	var newOn = (on + 1) % arrayLength;
	
	if (newOn != off)
	{
		fifo[on] = val;
		on = newOn;
	}
	else { beep(); }
}

function pull()
{
	var result;
	if (off != on)
	{
		result = fifo[off];
		off = (off + 1) % arrayLength;
		return result;
	}
	else { return -1; }
}

function process(newInterval)
{
	if (newInterval > 3000)
	{
		on = 0;
		off = 0;
		count = 0;
		oldTime = new Date().getTime();
		oldInterval = 0;
		sum = 0;
		newInterval = 652; // 92 bpm
		beatsPerMin.color = "#ffffff";
	}
	
	if (count >= sampleLength) { oldInterval = pull(); beatsPerMin.color = "#00ff00"; } else { count += 1; }
	push(newInterval);
	sum = sum + newInterval - oldInterval;
	average = sum / count;
	//print(Math.round(60000 / average));
	beatsPerMin.data = Math.round(60000 / average);
}

function onKeyDown()
{
	var d = new Date();
	var t = d.getTime();
	process(t - oldTime);
	oldTime = t;
}

function test()
{
	var rate = 100;

	oldTime = new Date().getTime();
	for (var i = 0; i < 60; i += 1)
	{
		sleep(60000/rate - 13);
		onKeyDown();
	}
}
